import { CacheType, ChatInputCommandInteraction, Message, PermissionFlagsBits, SlashCommandBuilder } from 'discord.js';
import ConfigManager from '../controller/ConfigManager';
import EcoManager from '../controller/EcoManager';
import { Pagination } from "pagination.djs"

// const { Pagination } = require('pagination.djs');

// const adminPermissions = new PermissionsBitField('Administrator');

export default {
  data: new SlashCommandBuilder()
    .setName('exec')
    .setDescription('Exec command')
    .addStringOption(opt => opt.setName("command").setDescription("Command").setRequired(true))
    .setDefaultMemberPermissions(PermissionFlagsBits.Administrator),
  async execute(interaction: ChatInputCommandInteraction<"cached">, config: ConfigManager) {
    const ecoManager = new EcoManager(config)

    const command = interaction.options.getString('command')

    await interaction.deferReply({ ephemeral: true })

    try {
      if (!command) {
        await interaction.followUp(`Ошибка выполнения команды. 0`);
        return
      }

      const status = await ecoManager.Exec(command)

      const pagination = new Pagination(interaction)
      pagination.setLimit(20)

      if (!!status && !status.Errored) {
        if (status.CommandMessages.filter(e => e.Type === "Notifications-Chat").length > 0) {
          if (status.CommandMessages.filter(e => e.Type === "Notifications-Chat")[0].Message.length <= 2000)
            await interaction.followUp(status.CommandMessages.filter(e => e.Type === "Notifications-Chat")[0].Message.substring(0, 2000) || "Команда выполнена")
          else {
            pagination.setDescriptions(status.CommandMessages.filter(e => e.Type === "Notifications-Chat")[0].Message.split("\n"))
            pagination.render();
          }
        } else
          await interaction.followUp(JSON.stringify(status).substring(0, 2000))
      } else {
        if (!!status && status.CommandMessages.filter(e => e.Type === "Notifications-Chat").length > 0)
          if (status.CommandMessages.filter(e => e.Type === "Notifications-Chat")[0].Message.length <= 2000)
            await interaction.followUp(status.CommandMessages.filter(e => e.Type === "Notifications-Chat")[0].Message.substring(0, 2000) || "Команда выполнена")
          else {
            pagination.setDescriptions(status.CommandMessages.filter(e => e.Type === "Notifications-Chat")[0].Message.split("\n"))
            pagination.render();
          }
        else
          await interaction.followUp(JSON.stringify(status).substring(0, 2000))
      }
      return
    } catch (error) {
      await interaction.followUp("Ошибка выполнения команды. 1")
      console.log(error)
    }
  },
};
