import { ActionRowBuilder, ButtonBuilder, ButtonStyle, CacheType, ChatInputCommandInteraction, Message } from "discord.js";
import ConfigManager from "./ConfigManager";
import axios from "axios";
import UserI from "../types/UserI";
import MessageI from "../types/MessageI";

export default class UserManager {
  config: ConfigManager
  public constructor(config: ConfigManager) {
    this.config = config
  }
  public async getMessages() {
    try {
      const { data, status } = await axios.get<MessageI[]>(`${process.env.ECO_API_BASE || "https://eco.kamgames.xyz"}/api/v1/chat`, {
        timeout: 5000,
        headers: {
          "X-API-Key": process.env.ECO_API_KEY
        }
      });

      if (status !== 200) return false

      console.log(data)

      return true
    } catch (error) {
      console.log(error)
    }
    return false
  }
  public async syncMessageWithDiscord() {
    if (!process.env.CHAT_CHANNEL_ID || !this.config.serverInfo) return false

    try {
      const { data, status } = await axios.get<MessageI[]>(`${process.env.ECO_API_BASE || "https://eco.kamgames.xyz"}/api/v1/chat?startDay=${(this.config.serverInfo.TimeSinceStart / 3600 - 10).toFixed(5)}`, {
        timeout: 5000,
        headers: {
          "X-API-Key": process.env.ECO_API_KEY
        }
      });

      if (status !== 200) return false

      console.log(data)

      return true
    } catch (error) {
      console.log(error)
    }

    return false
  }
}